<?php
/**
 * Plugin Name: Exit Popup Show
 * Plugin URI: https://troplr.com/
 * Description: Better exit popup for your website and blog
 * Version: 1.0
 * Author: Troplr
 * Author URI: https://troplr.com
 * Requires at least: 4.5
 * Tested up to: 4.7
 *
 * Text Domain: troplr
 *
 */

require_once('titan-framework/titan-framework-embedder.php');

function exitcss_dependencies() {

wp_register_style( 'exit-popup-css', plugins_url('css/ysExit.css', __FILE__) );
 wp_enqueue_style( 'exit-popup-css' );
}
add_action( 'wp_enqueue_scripts', 'exitcss_dependencies' );

 
add_action( 'tf_create_options', 'exit_popup_option' );
function exit_popup_option() {
// Initialize Titan & options here
 $titan = TitanFramework::getInstance( 'exit-popup-show' );

 $panel = $titan->createAdminPanel( array(
'name' => 'Exit Popup Show',
) );

$panel->createOption( array(
'name' => 'Width',
'id' => 'width',
'type' => 'text',
'size' => '20',
'default' => '500',
'desc' => 'Width of popup e.x: 500'
) );

$panel->createOption( array(
'name' => 'Height',
'id' => 'height',
'type' => 'text',
'size' => '20',
'default' => '500',
'desc' => 'Height of popup e.x: 500'
) );

$panel->createOption( array(
'name' => 'Delay',
'id' => 'delay',
'type' => 'text',
'size' => '20',
'desc' => 'Delay in milli seconds for the popup to activate'
) );

$panel->createOption( array(
'name' => 'Cookie Expiry (Days)',
'id' => 'cookies',
'type' => 'text',
'size' => '20',
'desc' => 'Cookie Expiry (Days) for each visitor'
) );

$panel->createOption( array(
'name' => 'Close popup on click outside',
'id' => 'click_popup_out',
'type' => 'select',
'options' => array(
'true' => 'true',
'false' => 'false',
),
'desc' => 'On "true" popup will close on clicking outside',
) );

$panel->createOption( array(
'name' => 'Hide Close Button',
'id' => 'hideclosebutton',
'type' => 'select',
'options' => array(
'yes' => 'Yes',
'no' => 'No',
),
'desc' => 'If selected "Yes" close button will not appear',
) );

$panel->createOption( array(
'name' => 'Overlay Background Color',
'id' => 'overlay_background_color',
'type' => 'color',
'desc' => 'Pick a color',
'default' => '#555555',
'alpha' => 'true'
) );

$panel->createOption( array(
'name' => 'Popup Box Background Color',
'id' => 'box_background_color',
'type' => 'color',
'desc' => 'Pick a color',
'default' => '#ffffff',
'alpha' => 'true'
) );

$panel->createOption( array(
'name' => 'Popup Box Margin-top',
'id' => 'box_margin_top',
'type' => 'text',
'desc' => 'Set margin top e.x: 50% OR 100px',
'default' => '50%'
) );

$panel->createOption( array(
'name' => 'Popup Box Margin-left',
'id' => 'box_margin_left',
'type' => 'text',
'desc' => 'Set margin from left e.x: 50% OR 100px',
'default' => '40px'
) );


$panel->createOption( array(
'type' => 'save'
) );

$panel->createOption( array(
'name' => '',
'id' => 'xpsgpay',
'type' => 'note',
'desc' => 'Thankyou for using <b>Exit Popup Show</b>.<br>You may want to support my development: <a target="_blank" href="https://paypal.me/sandeeptete">Paypal me a tip</a>'
) );

$panel->createOption(  array(
'name' => '',
'id' => 'xps_message_grid',
'type' => 'note',
'desc' => 'You may find other plugins from us to be useful below.<br><div class="autowide">
  <div class="module">
    <p><b><a href="https://wordpress.org/plugins/categories-gallery/">Bootstrap Categories Gallery</a></b></p>
  </div>
  <div class="module">
    <p><b><a href="https://wordpress.org/plugins/custom-scroll-bar-designer/">Custom Scrollbar Designer</a></b></p>
  </div>
  <div class="module">
    <p><b><a href="https://wordpress.org/plugins/custom-text-selection-colors/">Custom Text Selection Colors</a></b></p>
  </div>
  <div class="module">
    <p><b><a href="https://wordpress.org/plugins/disable-image-right-click/">Disable Image Right Click</a></b></p>
  </div>
  <div class="module">
    <p><b><a href="https://wordpress.org/plugins/easy-gallery-slideshow/">Easy Gallery Slideshow</a></b></p>
  </div>
  <div class="module">
    <p><b><a href="https://wordpress.org/plugins/exit-popup-show/">Exit Popup Show</a></b></p>
  </div>
  <div class="module">
    <p><b><a href="https://wordpress.org/plugins/popup-modal-for-youtube/">Popup Modal For Youtube</a></b></p>
  </div>
  <div class="module">
    <p><b><a href="https://wordpress.org/plugins/woo-availability-date/">Product Limited Time Availability Date for woocommerce</a></b></p>
  </div>
  <div class="module">
    <p><b><a href="https://wordpress.org/plugins/email-my-posts/">Share Posts To Email</a></b></p>
  </div>
  <div class="module">
    <p><b><a href="https://wordpress.org/plugins/custom-scroll-bar-designer/">Share Woocommerce to Email</a></b></p>
  </div>
  <div class="module">
    <p><b><a href="https://wordpress.org/plugins/share-woocommerce-email/">Custom Scrollbar Designer</a></b></p>
  </div>
  <div class="module">
    <p><b><a href="https://wordpress.org/plugins/total-sales-for-woocommerce/">Total Sales For Woocommerce</a></b></p>
  </div>
</div>'
) );
}

function xps_customcss()
{
  $xpscss = '<style>.autowide {
  margin: 0 auto;
  width: 98%;
}
.autowide img {
  float: left;
  margin: 0 .75rem 0 0;
}
.autowide .module {
  xbackground-color: lightgrey;
  border-radius: .25rem;
  margin-bottom: 1rem;
  color: #0f8cbb;
}
.autowide .module p {
  padding: 4px 0px;
}

/* 2 columns: 600px */
@media only screen and (min-width: 600px) {
  .autowide .module {
    float: left;
    margin-right: 2.564102564102564%;
    width: 48.717948717948715%;
  }
  .autowide .module:nth-child(2n+0) {
    margin-right: 0;
  }
}

/* 3 columns: 768px */
@media only screen and (min-width: 768px) {
  .autowide .module {
    width: 31.623931623931625%;
  }
  .autowide .module:nth-child(2n+0) {
    margin-right: 2.564102564102564%;
  }
  .autowide .module:nth-child(3n+0) {
    margin-right: 0;
  }
}

/* 4 columns: 992px and up */
@media only screen and (min-width: 992px) {
  .autowide .module {
    width: 23.076923076923077%;
  }
  .autowide .module:nth-child(3n+0) {
    margin-right: 2.564102564102564%;
  }
  .autowide .module:nth-child(4n+0) {
    margin-right: 0;
  }
}</style>';
echo $xpscss;

}
add_action('admin_head','xps_customcss');

function exit_popup()
{
$titan = TitanFramework::getInstance( 'exit-popup-show' );
$width = $titan->getOption( 'width' );
$height = $titan->getOption( 'height' );
$obgcolor = $titan->getOption('overlay_background_color');
$boxbgcolor = $titan->getOption('box_background_color');
$maincontent = $titan->getOption('body_content');
$closebutton = $titan->getOption('hideclosebutton');
$margintop = $titan->getOption('box_margin_top');
$marginleft = $titan->getOption('box_margin_left');

// Do stuff here
?>

<div class="ys-layer"></div>
<div class="ys-container" id="ys-container" style="background-color:<?php echo $obgcolor;?>">
	<div class="ys-box" style="left:<?php echo $marginleft;?>!important;top: <?php echo $margintop;?>!important;width:<?php echo $width;?>px;height:<?php echo $height;?>px;background-color:<?php echo $boxbgcolor;?>">

	<?php if ($closebutton == 'no'){
		?>
	<a class="ys-popup-close" href="#">x</a>
	<?php
	}
		elseif ($closebutton == 'yes'){
	?>
	<a style="display:none" class="ys-popup-close" href="#">x</a>
	<?php
	}
	?>
		<div class="ys-popup-content">

		<p><?php echo do_shortcode($maincontent);?></p>
		 
		<a  style="display:none" href="#" class="ys-exit">Exit</a>
		</div>
	 </div>
 </div>
<script>
var options = {
debug: true,
}
ysExit(options);
</script>

<?php
}
?>
<?php
function ysexit_header(){
	$titan = TitanFramework::getInstance( 'exit-popup-show' );
	$cookies = $titan->getOption( 'cookies' );
	$delay = $titan->getOption( 'delay' );
	$clickpopout = $titan->getOption( 'click_popup_out' );

?>
<script type="text/javascript">
	(function(w) {
	"use strict";
	w.ysExit = function(o) {
	var defaults = {
	//width: '30%', //popup width
	//height: '30%', //popup height
	target: '#ys-container', //popup selector
	cookieValidity:<?php echo $cookies;?>,//days
	closeOnOutsideClick: <?php echo $clickpopout;?>, //close popup if user clicks outside
	delay:<?php echo $delay;?>, //delay in ms until the popup is registered
	debug: false //if true, the cookie will not be set
	},
	options = fixOptions(o),
	element = document.querySelector(options.target),
	layer = document.querySelector('.ys-layer'),
	closeBt = document.querySelector(options.target + ' .ys-popup-close'),
	inner = document.querySelector(options.target + ' .ys-box'),
	exitBt = document.querySelector(options.target + ' .ys-exit'),
	//cookies management helper
	cookies = {
	set: function(name, value, days) {
	var components = [name + '=' + value];
	if (days) {
	var date = new Date();
	date.setTime(date.getTime() + (days * 24 * 3600 * 1000));
	components.push('expires=' + date.toGMTString());
	}

	components.push('path=/');
	document.cookie = components.join('; ');
	},
	get: function(name) {
	var start = name + '=',
	arr = document.cookie.split(';'),
	i;
	for(i = 0; i < arr.length; i++) {
	var item = arr[i].trim();
	if (item.indexOf(start) === 0){
	return item.substring(start.length);
	}
	}
	return null;
	}
	},
	//the popup object
	pop = {
	active: false,
	mouseLeftWindow: function(e) {
	var from, to;
	e = e ? e : window.event;
	from = e.relatedTarget || e.toElement;
	if (!from || from.nodeName === "HTML") {
	pop.open();
	}
	},
	setDimension: function(dimension, value) {
	if (value.toString().indexOf('%') === -1) {
	value = value + 'px';
	}

	inner.style[dimension] = value;
	},
	attachEvents: function() {
	function close(e) {
	pop.destroy();
	e.preventDefault();
	}

	document.addEventListener('mouseout', pop.mouseLeftWindow, false);
	closeBt.addEventListener('click', close);
	exitBt.addEventListener('click', close);

	if (options.closeOnOutsideClick) {
	element.addEventListener('click', close);
	inner.addEventListener('click', function(e) {
	e.stopPropagation();
	});
	}

	this.active = true;
	},
	detachEvents: function() {
	document.removeEventListener('mouseout', pop.mouseLeftWindow);
	},
	open: function() {
	var self = this;
	element.classList.add('visible');
	layer.classList.add('visible');
	self.detachEvents();
	setTimeout(function() {
	self.setDimension('width', options.width);
	self.setDimension('height', options.height);
	}, 20);
	setTimeout(function() {
	element.classList.add('finished');
	}, 200);
	},
	destroy: function() {
	if (this.active) {
	pop.detachEvents();
	setTimeout(function () {
	element.parentNode.removeChild(element);
	layer.classList.remove('visible');
	}, 200);
	 
	if (!options.debug) {
	cookies.set('ysExit', 1, options.cookieValidity);
	}
	}
	}
	};

	//helper functions
	function fixOptions(options) {
	var newOptions = {};

	Object.keys(defaults).forEach(function(key) {
	newOptions[key] = options.hasOwnProperty(key) ? options[key] : defaults[key];
	});

	return newOptions;
	}
	function delegate(obj, func) {
	return function() {
	func.apply(obj, arguments);
	};
	}

	 //start logic
	if (!cookies.get(options.cookieIdentifier)) {
	if (typeof options.delay !== 'number') {
	throw new Error('options.delay must be a numeric value');
	}
	if (!element) {
	throw new Error('Could not find element with selector: ' + options.target);
	 }
	 
	 if (element.parentNode !== document.body) {
	 throw new Error(options.target + ' element must be placed directly inside of the <body> element');
	 }
	 
	 setTimeout(delegate(pop, pop.attachEvents), options.delay);
	 }
	 
	 //return object with public interface
	 return {
	 open: delegate(pop, pop.open),
	 destroy: delegate(pop, pop.destroy),
	 getElement: function() {
	 return element;
	 }
	 };
	 };
	})(window);
 </script>

<?php
}
	add_action( 'wp_footer', 'exit_popup', 10 );
	add_action('wp_head', 'ysexit_header', 10);
?>